VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "ThisDrawing"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = True
Option Explicit
Sub main()
    Dim retVal As String
    While retVal = ""
        retVal = ThisDrawing.Utility.GetString _
            (1, vbCrLf & "Enter your name: ")
    Wend
    MsgBox "Hello " & retVal & ". Let's draw a line."
    Dim startPnt As Variant
    Dim endPnt As Variant
    Dim prompt1 As String
    Dim prompt2 As String
    prompt1 = vbCrLf & "Enter the start point of the line, " & retVal & ": "
    prompt2 = vbCrLf & "Thank you " & retVal & _
        ". Now, enter the end point of the line: "
    'Get the first point without entering a base point
    ThisDrawing.Utility.InitializeUserInput 1
    startPnt = ThisDrawing.Utility.GetPoint(, prompt1)
    'Use the point entered above as the base point
    ThisDrawing.Utility.InitializeUserInput 1
    endPnt = ThisDrawing.Utility.GetPoint(startPnt, prompt2)
    'Create a line using the two points entered
    MsgBox "That's great " & retVal & "." & vbCrLf & _
           "A new Line object is being added." & vbCrLf & _
           "Start point = " & startPnt(0) & "," & startPnt(1) & "," & _
           startPnt(2) & vbCrLf & "End point = " & endPnt(0) & "," & _
           endPnt(1) & "," & endPnt(2)
    Dim lineObj As AcadLine
    Set lineObj = ThisDrawing.ModelSpace.AddLine(startPnt, endPnt)
    ThisDrawing.Application.ZoomAll
    Dim keyWord As String
    ThisDrawing.Utility.InitializeUserInput 0, "Yes No"
    keyWord = ThisDrawing.Utility.GetKeyword(vbCrLf & _
        "Do you want to change the length of the line " & _
        retVal & "(Yes/<No>)?: ")
    If keyWord = "" Then keyWord = "No"
    If keyWord = "No" Then
        MsgBox "Thank you " & retVal & "!"
    Else
        MsgBox "No problem " & retVal & "." & vbCrLf & _
            "You can change the length to half or double the" & vbCrLf & _
            "current value, or specify a different length"
    End If
    If keyWord = "Yes" Then
        'The parameter of InitializeUserInput (2)
        'restricts input to non-zero values.
        ThisDrawing.Utility.InitializeUserInput 2, "Double Half Current"
        'Set the prompt string variable
        Dim promptStr As String
        promptStr = vbCrLf & "Enter the new length or (Double/Half/<Current>):"
        'At the GetReal prompt, entering a keyword or pressing
        'ENTER without entering a value results in an error. To allow
        'your application to continue and check for the error
        'description, you must set the error handler to resume on error.
        On Error Resume Next
        'Get the value entered by the user
        Dim returnDouble As Double
        returnDouble = ThisDrawing.Utility.GetReal(promptStr)
        'Check for an error. If the error number matches the
        'one shown below, then use GetInput to get the returned
        'string; otherwise, use the value of returnDouble.
        Dim lineAng As Double
        Dim lineLen As Double
        lineLen = lineObj.Length
        lineAng = lineObj.Angle
        If Err.Number = -2145320928 Then
            Dim returnString As String
            Debug.Print Err.Description
            returnString = ThisDrawing.Utility.GetInput()
            If returnString = "" Then 'ENTER returns null string
                returnString = "Current" 'Set to default
            ElseIf returnString = "Double" Then
                MsgBox "Good choice " & retVal & "." & vbCrLf & _
                       "The length of the line will now be doubled," & vbCrLf & _
                       "from " & CStr(lineLen) & " to " & CStr(lineLen * 2) & "."
                lineObj.EndPoint = ThisDrawing.Utility.PolarPoint(startPnt, _
                    lineAng, lineLen * 2)
            ElseIf returnString = "Half" Then
                MsgBox "Good choice " & retVal & "." & vbCrLf & _
                       "The length of the line will now be halved," & vbCrLf & _
                       "from " & CStr(lineLen) & " to " & CStr(lineLen / 2) & "."
                lineObj.EndPoint = ThisDrawing.Utility.PolarPoint(startPnt, _
                    lineAng, lineLen / 2)
            End If
        Else 'Otherwise use the value entered
            MsgBox "Good choice " & retVal & "." & vbCrLf & _
                   "The length of the line will now be changed," & vbCrLf & _
                   "from " & CStr(lineLen) & " to " & CStr(returnDouble) & "."
            lineObj.EndPoint = ThisDrawing.Utility.PolarPoint(startPnt, _
                lineAng, returnDouble)
        End If
        Err.Clear
    End If
End Sub
